// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.datasource.handler;

import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.ui.handlers.HandlerUtil;

import eu.etaxonomy.cdm.database.CdmPersistentDataSource;
import eu.etaxonomy.taxeditor.datasource.CdmDataSourceRepository;

/**
 * @author n.hoffmann
 * @created 15.04.2009
 * @version 1.0
 */
public class DeleteDataSourceHandler extends AbstractDataSourceHandler {

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.store.datasource.handler.AbstractDataSourceHandler#specificExecute(org.eclipse.core.commands.ExecutionEvent)
	 */
	@Override
	public Object specificExecute(ExecutionEvent event) {
		ISelection menuSelection = HandlerUtil.getActiveMenuSelection(event);
		CdmPersistentDataSource dataSource = (CdmPersistentDataSource) ((StructuredSelection) menuSelection).getFirstElement();
		
		// Delete from persistent data sources		
		CdmDataSourceRepository.getDefault().delete(dataSource);
		return null;
	}
}
