/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.preference;

import org.eclipse.ui.IWorkbenchPreferencePage;

import eu.etaxonomy.cdm.model.name.Rank;
import eu.etaxonomy.taxeditor.store.VocabularyStore;

/**
 * Allows the user to choose which <code>Rank</code>s to display in the 
 * <code>PropertySheet</code> drop-down menu for <code>TaxonNameBase</code>.
 * 
 * @author p.ciardelli
 * @created 17.09.2008
 * @version 1.0
 * @author n.hoffmann
 */
public class RankMenuPreferences extends AbstractMenuPreferences<Rank> implements
		IWorkbenchPreferencePage {

	public static final String PLUGIN_ID = "eu.etaxonomy.taxeditor.preferences.ranks";

	public RankMenuPreferences() {
		super(VocabularyStore.getRanks(), 
				"Rank Preferences", 
				"Choose which ranks to display in the property sheet drop-down menu.");
	}

}
